% MIQP solver
% Tianyang Ma , Latecki  09/29/2011


function [fvalue,x_star, itercount] = MIQP_solver(w,x,y)
% a is the binary connection matrix
% w is the weight matrix
% x is the discrete solution
% y is the continuous approxmiate to x
thres = 0.0000000000000000001;
%function definitions
f = @(x) x'*w*x; %the target function
itercount = 0;
% initialization
y_t = y;
x_star = x;
gofy = 10;
% iteration to update
while  (gofy > thres) && (itercount <3000)
    itercount = itercount+1;
    x_bar = w'*y_t>=0; % it is discrete
    if(norm(x_bar - y_t)==0)
        x_star = x_bar;
        break;
    end
    if f(x_bar)>f(y_t)
        y_t1 = x_bar;
        x_star = x_bar;
    else
        eta = -((w'*y_t)'*(x_bar-y_t))/(((x_bar-y_t)'*w*(x_bar-y_t))+eps);
        y_t1 = y_t + eta*(x_bar - y_t);
    end
    gofy = norm(y_t1 - y_t);
    y_t  = y_t1;
end
fprintf('\nitercount = %d,  gofy = %f, sum(x) = %d\n', itercount, gofy, sum(x_star));
fvalue = f(x_star);