% data normalization
% Input:
% X : data
% type:
%       0--  no normalization
%       1--  normailization: zeros mean, unit variance
%       2--  normailization: zeros mean, unit length
%       3--  normailization: scale range
%       default: 1

function X = data_norm(X, type)

if(~exist('type', 'var'))
    type = 1;
end
if( type == 0)
    X = X;
elseif (type == 1)
    %normailization: zeros mean, unit variance
    mean_x = mean(X);
    std_x = std(X);
    mean_x = repmat(mean_x,[size(X,1) 1]);
    std_x = repmat(std_x,[size(X,1) 1]);
    X = (X- mean_x)./(std_x+eps);
elseif (type == 2 )
    % normailization: zeros mean, unit length
    mean_x = mean(X);
    mean_x = repmat(mean_x,[size(X,1) 1]);
    X = X- mean_x;
    sum_x = sum(abs(X));
    sum_x = repmat(sum_x,[size(X,1) 1]);
    X = X./sum_x;
else
    % normailization: scale range
    min_x = min(X);
    max_x = max(X);
    min_x = repmat(min_x,[size(X,1) 1]);
    max_x = repmat(max_x,[size(X,1) 1]);
    X = (X- min_x)./(max_x-min_x+eps);
end
