function [fea_, cFea] = ensemble_lasso(data,label,FeaNum)

[d1,d2] = size(data);

options.ReguAlpha = 0.001; %This parameter can be changed
options.ReguType = 'RidgeLasso';
FeaNumCandi = FeaNum;
options.LassoCardi =  FeaNumCandi;

LassoCardi = FeaNum + 10;

alphaP = []; 
for folder = 1:10
    %te = 1:d1;
    te = randperm(d1);
    test_index = te(1:floor(d1/20));
    train_index = setdiff(1:d1,test_index);
    
    train_data = data(train_index,:);
    test_data = data(test_index,:);
    train_label = label(train_index);
    test_label = label(test_index);
    
    Y = train_label;
    
    global Gram;
    Gram = train_data'*train_data;
    Gram = max(Gram,Gram');
            
    if options.ReguAlpha > 0
       for i=1:size(Gram,1)
           Gram(i,i) = Gram(i,i) + options.ReguAlpha;
       end
    end
    
   eigvectorAll = lars(train_data, Y, 'lasso', -LassoCardi,1,[],options.LassoCardi);
   
   clear global Gram;
   for i = 1:length(FeaNumCandi)
        eigvector = eigvectorAll;
        eigvector = max(abs(eigvector),[],2);
        alphaP = [alphaP, eigvector];
  end
end

alpha_mean = mean(alphaP, 2);
[~, idx] = sort(alpha_mean, 'descend');
alphaP = (alphaP(idx, :));
countFea  = sum(double(alphaP>0),2);
[cFea, idx1] = sort(countFea, 'descend');
fea_ = idx(idx1);
alphaP = alphaP(idx1, :);





