clear; clc; close all;

%% add datapath
addpath(genpath('libsvm-3-20'));

%% parameter setting
folderNum = 10;
options.minNum     = 1;
options.maxNum     = 20;
options.normType    = 1;
options.LassoCardi = 15;
options.thresh = 0.8; % tuned depend on the correlation matrix of data
options.ReguAlpha = 0.001; 
options.ReguType = 'RidgeLasso';

%% data information
dataPath = 'data/';
datasets  = dir([dataPath, '*.mat']);

%% run algorithms
for i = 1 : length(datasets)
    fprintf('processing %d dataset: %s...\n', i, datasets(i).name);
    data = fullfile(dataPath, datasets(i).name);
    load(data);
    X = data_norm(X,1);
    % randomly generate fold dataset
    [trainData, testData, trainLabel, testLabel] = folder_data_multi(X,y,folderNum);
    % run the algorithms with stability lasso
    [acc_iter] = stability_selection(trainData, testData, trainLabel, testLabel, options);
    fprintf('accuracy = %f.\n',mean(acc_iter,1));  
end

disp('Finished');
